import { OnInit, EventEmitter, QueryList } from '@angular/core';
import { Tree } from '../../models/tree.model';
import { IconDefinition } from '@fortawesome/free-solid-svg-icons';
import { Leaf } from '../../models/leaf.model';
import { LeafClickedEvent } from '../../models/leaf-clicked-event.model';
import { ILoggingService } from '../../interfaces/ILoggingService.interface';
import { NgxBootstrapTreeviewMapper } from '../../utils/ngx-bootstrap-treeview-mapper';
import { NgxBootstrapTreeviewContextMenus } from '../../models/ngx-bootstrap-treeview-context-menus.model';
export declare class NgxBootstrapTreeviewComponent implements OnInit {
    leafClicked: EventEmitter<LeafClickedEvent>;
    loggingService: ILoggingService;
    tree: Tree;
    trees: Tree[];
    mapper: NgxBootstrapTreeviewMapper<Object, Object>;
    item: Object;
    items: Object[];
    isOpened: boolean;
    canSelectBranch: boolean;
    openedFolderIcon: IconDefinition;
    closedFolderIcon: IconDefinition;
    unselectedLeafIcon: IconDefinition;
    selectedLeafIcon: IconDefinition;
    anyChildrenSelectedIcon: IconDefinition;
    allChildrenSelectedIcon: IconDefinition;
    emptyFolderLabel: string;
    contextMenus: NgxBootstrapTreeviewContextMenus;
    isFirstLevel: boolean;
    children: QueryList<NgxBootstrapTreeviewComponent>;
    childrenState: string;
    selectedLeaves: Leaf[];
    leavesCount: number;
    isBranch: boolean;
    isLeaf: boolean;
    isRoot: boolean;
    lastContextMenuEvent: MouseEvent;
    constructor();
    ngOnInit(): void;
    itemClicked(leafClickedEvent?: LeafClickedEvent): void;
    leafClickedCallback(): void;
    countLeaves(tree: Tree): number;
    select(value: number | string): void;
    unselect(value: number | string): void;
    toggle(value: number | string): void;
    onContextMenu(event: MouseEvent): void;
    onElementAdded(): boolean;
    fold(id: number | string): void;
    unfold(id: number | string): void;
    private _selectLeaf;
    private _unselectLeaf;
    private _leafClickedEventReceived;
    private _leafIndex;
    private _leafExistsIn;
}
